<template>
  <div class="d-md-flex align-items-center justify-content-betwenn flex-wrap p-2 pb-4 contenedorPrincipal">
    <div class="col-2 ms-3 mt-3">
      <label for="periodo" class="form-label d-block">Per&iacute;odo:</label>
      <select required v-model="form.periodo" class="form-select form-select-sm" id="periodo">
        <option :value="null" v-text="'--Seleccione--'"></option>
        <option v-for="periodo in periodosStore.periodos.anual" :key="periodo.id_periodo" :value="periodo"
          v-text="periodo.anioActivo">
        </option>
      </select>
    </div>
    <div class="col-4 ms-3 mt-3">
      <label for="solicitante" class="form-label d-block">Solicitante:</label>
      <auto-complete class="d-inline w-25" v-model="form.solicitante" :elements="solicitantesStore.solicitantes"
        initKey="" placeholder="Apellido/s y Nombre/s" :minLength="2" :required="false" autocomplete="off"
        id="solicitante" />
      <p v-show='haySolicTotalDisp === false' class="text-danger" v-html='"El solicitante no tiene cupo disponible"'></p>
      <p v-show='haySolicTotalDisp === true' class="text-success"
        v-html='"Cupo disponible del solicitante: " + importeMostrar(form.solicitante?.tot_disponible)'></p>
    </div>
    <div class="col-4 ms-3 mt-3">
      <label for="cargo" class="form-label d-block">Cargo:</label>
      <auto-complete class="d-inline w-25" v-model="form.cargo" :elements="cuposStore.listadoCargos" initKey=""
        placeholder="Cargo" :minLength="2" :required="false" autocomplete="off" id="cargo" />
    </div>
    <div class="col mt-4 text-end me-2">
      <button type="button" class="btn btn-principal px-2 mt-2" alt="Buscar solicitantes" title="Buscar solicitantes"
        @click="validarBuscarSolicitantes()">
        <i class="bi bi-search "></i>
      </button>
    </div>
  </div>
  <div class="row mb-3" v-show="haySolicitantes">
    <div class="col text-end">
      <button type="button" class="btn mt-1 p-1 px-2 mx-2 btn-crear" alt="Imprimir listado de solicitantes"
        title="Imprimir listado de solicitantes" @click="exportarSolicitantes()">
        <i class="fa-solid fa-file-pdf fs-7"></i> Imprimir Listado
      </button>
    </div>
  </div>
</template>

<script setup lang="ts">
// Librerías
import { DateTime } from "luxon";
import type { DurationUnits } from "luxon";
import { onMounted, reactive, computed, ref, watch, watchEffect, nextTick } from "vue";
import type { Ref } from "vue";
import http from "@/http";
import type { AxiosResponse, AxiosError } from "axios";
import Swal from "sweetalert2/dist/sweetalert2.js";
import type { SweetAlertOptions } from "sweetalert2";
import { AutoComplete } from "@hcd-bsas/vue3-components";
import { loading, isEmpty, urlApi, urlComun } from "@/shared.js";
// Entidades
import { Usuariohabilitado } from "@/entities/Usuariohabilitado";
import type Periodo from "@/entities/Periodo";
import type Solicitante from "@/entities/Solicitante";
import Cargo from "@/entities/Cupos/Cargo";
// Stores
import { useUsuariosStore } from "@/stores/usuarios";
import { usePermisosAppStore } from "@/stores/permisosApp";
import { usePeriodosStore } from "@/stores/periodos";
import { useSolicitantesStore } from "@/stores/solicitantes";
import { useCuposStore } from "@/stores/Cupos/cupos";

const usuariosStore = useUsuariosStore();
const permisosAppStore = usePermisosAppStore();
const periodosStore = usePeriodosStore();
const solicitantesStore = useSolicitantesStore();
const cuposStore = useCuposStore();

const emits = defineEmits(["ocultarGrilla", "mostrarGrilla", "actUsarPerfilConsulta"]);

const importeMostrar = (importe: number | undefined) => (!isEmpty(importe)) ? Intl.NumberFormat("es-AR", { style: 'currency', currency: 'ARS', minimumFractionDigits: 2 }).format(importe!) : null;
//const fechaEsMenor = (fecha_1: string, fecha_2: string) => DateTime.fromISO(fecha_1).startOf("day") < DateTime.fromISO(fecha_2).startOf("day");
//const fechasDif = (f_minuendo: string, f_sustraendo: string, unidad: DurationUnits) => DateTime.fromISO(f_minuendo).diff(DateTime.fromISO(f_sustraendo), unidad).toObject();
//const fechaEsMismoAnio = (fecha_1: string, fecha_2: string) => fechasDif(fecha_1, fecha_2, 'years').years! === 0;
const fechaAnio = (fecha: string) => DateTime.fromISO(fecha).year;

const usuarioActivo = ref(null) as Ref<Usuariohabilitado | null>;
const periodoActivo = computed(() => periodosStore.periodos.activo);
const hayPeriodo = computed(() => !isEmpty(form.periodo));
const haySolicitante = computed(() => !isEmpty(form.solicitante));
const hayCargo = computed(() => !isEmpty(form.cargo));
const haySolicTotalDisp = computed(() => haySolicitante.value ? ((form.solicitante!.tot_disponible > 0) ? true : false) : null);
const haySolicitantes = computed(() => solicitantesStore.solicConsulta.length > 0);

const form = reactive({
  periodo: null as Periodo | null,
  solicitante: undefined as Solicitante | undefined,
  cargo: undefined as Cargo | undefined
});

watch(haySolicitante, (newValue, oldValue) => {
  if (newValue !== oldValue) {
    if (!newValue) {
      ocultarGrilla();
    }
    else {
      validarBuscarSolicitantes();
    }
  }
});

function ocultarGrilla() {
  emits("ocultarGrilla");
}

function mostrarGrilla() {
  emits("mostrarGrilla");
}

function actUsarPerfilConsulta() {
  emits("actUsarPerfilConsulta", (usuarioActivo.value?.id_perfil_consulta === 2) ? 1 : 0);
}

async function validarBuscarSolicitantes() {
  const swal: SweetAlertOptions = {
    icon: "error",
    title: "Error",
    html: "",
  };
  if (!hayPeriodo.value) {
    swal.html = 'Por favor, seleccione un per&iacute;odo v&aacute;lido.';
  }
  /*
  else if (fechaEsMenor(form.f_hasta!.valueOf(), form.f_desde!.valueOf())) {
    swal.html = 'Por favor, compruebe que el campo "Fecha Hasta" no sea anterior a "Fecha Desde".';
  } else if (!fechaEsMismoAnio(form.f_desde!.valueOf(), form.f_hasta!.valueOf())) {
    swal.html = 'Por favor, compruebe que los campos "Fecha Desde" y "Fecha Hasta" tengan ingresado el mismo a&ntilde;o.';
  } 
  */
  if (!isEmpty(swal.html)) {
    Swal.fire(swal);
    return;
  }
  buscarSolicitantes();
}

async function buscarSolicitantes() {
  const paramsRequest: Object = {
    listar_proyectos: 0,
    periodo: form.periodo?.anioActivo,
    id_cargo: form.cargo?.id_cargo,
    id_tabla_sol: form.solicitante?.id_tabla_sol,
    usar_perfil_consulta: (usuarioActivo.value?.id_perfil_consulta === 2) ? 1 : 0
  };
  if (!loading.isLoading()) {
    loading.show();
    ocultarGrilla();
  }
  if (await solicitantesStore.fetchSolicConsulta(paramsRequest)) {
    mostrarGrilla();
  }
  loading.hide();
}

async function exportarSolicitantes() {
  const paramsRequest = {
    listar_proyectos: 0,
    periodo: form.periodo!.anioActivo,
    id_cargo: form.cargo?.id_cargo,
    id_tabla_sol: form.solicitante?.id_tabla_sol,
    usar_perfil_consulta: (usuarioActivo.value?.id_perfil_consulta === 2) ? 1 : 0,
    id_random: Math.floor(Math.random() * Number.MAX_SAFE_INTEGER)
  };
  const url: string = "exportSolicitantes";
  const queryParams: string = "?listar_proyectos=" + paramsRequest.listar_proyectos + "&" +
    "periodo=" + paramsRequest.periodo + "&" +
    (hayCargo.value ? ("id_cargo=" + paramsRequest.id_cargo + "&") : "") +
    (haySolicitante.value ? ("id_tabla_sol=" + paramsRequest.id_tabla_sol + "&") : "") +
    "usar_perfil_consulta=" + paramsRequest.usar_perfil_consulta + "&" +
    "id_random=" + paramsRequest.id_random;
  window.open(urlApi + url + queryParams, '_blank');
}

onMounted(async () => {
  const idUsuarioActivo: string = permisosAppStore.currentUser!.id_usuario!;
  const promiseUsuarioHab: Promise<Usuariohabilitado | null> = usuariosStore.findUsuarioByIdUsuario(idUsuarioActivo);
  let promisePeriodos: Promise<boolean>;
  let promiseSolicitantes: Promise<boolean>;
  let promiseCupos: Promise<void>;
  let promises: Promise<unknown>[] = [];
  loading.show();
  ocultarGrilla();
  promises.push(promiseUsuarioHab);
  if (isEmpty(periodosStore.periodos.listado) || isEmpty(solicitantesStore.solicitantes) || isEmpty(cuposStore.listadoCargos)) {
    promisePeriodos = periodosStore.fetchPeriodos();
    promiseSolicitantes = solicitantesStore.fetchSolicYProyectos();
    promises.push(promiseSolicitantes);
    if (isEmpty(cuposStore.listadoCargos)) {
      await promisePeriodos;
    } else {
      promises.push(promisePeriodos);
    }
  }
  if (isEmpty(cuposStore.listadoCargos) && !isEmpty(periodoActivo.value)) {
    promiseCupos = cuposStore.updateListadoCargos({ periodo: periodoActivo.value!.anioActivo, viene_de: "B" });
    promises.push(promiseCupos);
  }
  await Promise.all(promises).then(async (values) => {
    if (Swal.getIcon()?.classList.contains("swal2-error") !== true) {
      usuarioActivo.value = await promiseUsuarioHab;
      usuarioActivo.value!.id_perfil_consulta = Number(usuarioActivo.value?.id_perfil_consulta);
      actUsarPerfilConsulta();
      form.periodo = periodoActivo.value;
      buscarSolicitantes();
    } else {
      loading.hide();
    }
  }).catch(function () {
    loading.hide();
  });
})
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
